#ifndef gemc_MAINGUI_H
#define gemc_MAINGUI_H

// Qt headers
#include <QComboBox>
#include <QGroupBox>
#include <QLCDNumber>
#include <QLineEdit>
#include <QObject>
#include <QPushButton>
#include <QSlider>
#include <QVBoxLayout>
#include <QWidget>
#include <QListWidgetItem>
#include <QStackedWidget>

// G4 headers
#include "G4Material.hh"
#include "G4RunManager.hh"
#include "G4VisManager.hh"
#include "G4UImanager.hh"

// gemc headers
#include "sensitiveDetector.h"
#include "options.h"
#include "runControl/run_control.h"
#include "camera_control.h"
#include "detector_tree.h"
#include "infos.h"
#include "g4dialog.h"
#include "gsignal.h"


// Class definition

class gemcMainWidget : public QWidget
{
  // metaobject required for non-qt slots
	Q_OBJECT
	
	public:
		gemcMainWidget(goptions*, G4RunManager*, map<string, sensitiveDetector*>, map<string, detector>*, map<string, G4Material*>);
		~gemcMainWidget();
		  
		goptions *gemcOpt;
		
	G4RunManager *RM;
	
	private:
    gsignal *gsig;
  
	private slots:
		
		// we need to delete runManager before quitting the qApp
		// looks like no need to delete the visManager
	void  gemc_quit(){delete RM; cout << endl << " Arrivederci! " << endl << endl; qApp->quit();}
		
	private:
		void createIcons();
		
		QListWidget *contentsWidget;
		QStackedWidget *pagesWidget;
		QColor i_default;
		QColor i_hovered;
		
	public slots:
		void changePage(QListWidgetItem *current, QListWidgetItem *previous);
		void change_background(QListWidgetItem*);
		
};

#endif



