#ifndef vtxControls_H
#define vtxControls_H 1

// Qt headers
#include <QSlider>
#include <QLabel>
#include <QtGui>

// gemc headers
#include "options.h"


class vtxControls : public QWidget
{
	Q_OBJECT
	
	public:
		
		vtxControls(goptions *Opts, QWidget *parent, string type);

	public:
		QSlider *vx_slider;
		QSlider *vy_slider;
		QSlider *vz_slider;
		QSlider *rv_slider;
		QSlider *rvz_slider;
	
		double vx_slider_range;
		double vy_slider_range;
		double vz_slider_range;

		double vx_slider_scale;
		double vy_slider_scale;
		double vz_slider_scale;
	
		double rv_slider_range;
		double rvz_slider_range;
	
		double rv_slider_scale;
		double rvz_slider_scale;

		double get_vx_from_slider(){ return  vx_slider->sliderPosition()*vx_slider_scale;}
		double get_vy_from_slider(){ return  vy_slider->sliderPosition()*vy_slider_scale;}
		double get_vz_from_slider(){ return  vz_slider->sliderPosition()*vz_slider_scale;}
	
		double get_rv_from_slider() { return   rv_slider->sliderPosition()*rv_slider_scale;}
		double get_rvz_from_slider(){ return  rvz_slider->sliderPosition()*rvz_slider_scale;}

	
		QLabel *vxyz_ro;
		QLabel *vdr_ro;
		QLabel *vdz_ro;
		
		void set_vxyz_ro();
		void set_vdr_ro();
		void set_vdz_ro();
			
		QGroupBox *vroGroup;
		QGroupBox *vertexGroup;
	
};

#endif






